      PROGRAM GENERATE_MAP
	implicit double precision(a-h,o-z)
      INCLUDE 'c_all.INC'
      CHARACTER*255   TEMP,    FORM1,  FORM2,   FORM0, infile, outfile, 
     :				modfile
	dimension igrf(2),posf(2)
      EXTERNAL LHNL
      DATA PER,NI,IP,RED,EPS/0.0001,500,1,.5,1.E-10/	

	open (5,file='qtl-map.par')
	do i=1,10
	read(5,'(a255)') temp
	end do
	read(5,'(a255)') infile
	read(5,'(a255)') modfile
	read(5,'(a255)') outfile
	read(5,'(i2)') ncurtr
	read(5,'(i2)') ngentofix
	if (ngentofix.lt.0.or.ngentofix.gt.2) call
     :			sstop('number of genes to fix 0,1 or 2')
        INCLUDE 'LOADDAT.F'
        INCLUDE 'LOADMOD.F'
	do i=1,ngentofix
	  read(5,'(i3,f8.3)') igrf(i), posf(i)
c	  write(*,'(2i3,f8.3)') ngr,igrf(i), posf(i)
	  if (igrf(i).gt.ngr.or.igrf(i).le.0) then 
	    call sstop(' Groups to fix genes in are incorrect. 
     :Should be from 1 to number of groups')
	   end if
	end do
	if (ncurtr.gt.ntra.or.ncurtr.le.0) call 
     :		sstop('incorrect number for the trait to analyse')
	close(5)

	print*,'INPUT STEP FOR LINEAR SCAN:'
	read(*,*) step
        OPEN(2,FILE=outfile)

c	do i=1,nind
c	print *,tra(i,ncurtr)
c	end do

      IFLINK=0
      CALL METHGI(NPR,EPS,RED,PER,NI,IP,lhnl)
      CALL LHNL(pLHDEN)
      PRINT *,' LH NOT LINKED=',pLHDEN
      WRITE(2,'(F5.2,E16.8,16F8.4)') -99.,PLHDEN,(PR(K),K=1,16)
c
c	linear scan
c
	PMAXL=PLHDEN
      do icurgr=1,ngr
	do i5=1,ngentofix
	  if (icurgr.eq.igrf(i5)) goto 401
	end do
      begpos=pos(stpos(icurgr)+1)
      finpos=pos(stpos(icurgr+1))
      PKURPOS=begpos
	print '(a15,i3,a14,f5.2,a14,f5.2)','scan: group ',icurgr,
     :		'; start at ',begpos,'; finish at ',finpos
	write(2,'(a15,i3,a14,f5.2,a14,f5.2)')'scan: group ',icurgr,
     :		'; start at ',begpos,'; finish at ',finpos
      IFLINK=1
        DO WHILE (PKURPOS.LE.finpos)
	  INCLUDE 'BEFMETH.F'
	  icg1=icurgr
	if (ngentofix.ge.1) icg1=igrf(1)
	  icg2=icurgr
	if (ngentofix.eq.2) icg2=igrf(2)
	  icg3=icurgr
	  pkp1=PKURPOS
	if (ngentofix.ge.1) pkp1=posf(1)
	  pkp2=PKURPOS
	if (ngentofix.eq.2) pkp2=posf(2)
	  pkp3=PKURPOS
	  call calcpos
          CALL METHGI(NPR,EPS,RED,PER,NI,IP,lhnl)
          CALL LHNL(pLHNUM)
	  IF (PLHNUM.GT.PMAXL) PMAXL=PLHNUM
	  do jjj=(stpos(icurgr)+1),stpos(icurgr+1)
	  if (pkurpos.lt.pos(jjj)) goto 200
	  end do
200	  continue
	  il=jjj-1
	  pinin=pkurpos-pos(il)
          WRITE(2,'(F6.2,i3,f5.1,A11,f10.5,A5,f10.5,16F8.4)') 
     :		PKURPOS,il,pinin,' -2LN(LIK)=',-2.*PLHNUM,' LOD=',
     :		PLHNUM-PLHDEN,(PR(K),K=1,16)
c          PRINT *,' LH LINKED=',pLHNUM
          PRINT *,'POS,LOD',PKURPOS,pLHNUM-pLHDEN
          PKURPOS=PKURPOS+STEP
        END DO
401	continue
      end do

	WRITE(2,'(A10,F10.5)')'MAX.LOD=',PMAXL-PLHDEN

	if (ngentofix.gt.0) goto 102
	print *,' permute? (0/number)'
	read(*,*) ifp
	if (ifp.le.0) goto 102

	DO I=1,NIND
	DO J=1,MAXTRA
	TRA_OLD(I,J)=TRA(I,J)
	END DO
	DO J=1,MAXMARK
	MARK_OLD(I,J)=MARK(I,J)
	END DO
	END DO

	do iperm=1,ifp
	call permute
      IFLINK=0
      CALL METHGI(NPR,EPS,RED,PER,NI,IP,lhnl)
      CALL LHNL(pLHDEN)
      PRINT *,' LH NOT LINKED=',pLHDEN
C      WRITE(2,'(F5.2,E16.8,16F8.4)') -9.,PLHDEN,(PR(K),K=1,16)
	PMAXL=PLHDEN
      do icurgr=1,ngr
	do i5=1,ngentofix
	  if (icurgr.eq.igrf(i5)) goto 402
	end do
      begpos=pos(stpos(icurgr)+1)
      finpos=pos(stpos(icurgr+1))
      PKURPOS=begpos
C	print '(a15,i3,a14,f5.2,a14,f5.2)','scan: group ',icurgr,
C     :		'; start at ',begpos,'; finish at ',finpos
C	write(2,'(a15,i3,a14,f5.2,a14,f5.2)')'scan: group ',icurgr,
C     :		'; start at ',begpos,'; finish at ',finpos
      IFLINK=1
        DO WHILE (PKURPOS.LE.finpos)
	  INCLUDE 'BEFMETH.F'
	  icg1=icurgr
	if (ngentofix.ge.1) icg1=igrf(1)
	  icg2=icurgr
	if (ngentofix.eq.2) icg2=igrf(2)
	  icg3=icurgr
	  pkp1=PKURPOS
	if (ngentofix.ge.1) pkp1=posf(1)
	  pkp2=PKURPOS
	if (ngentofix.eq.2) pkp2=posf(2)
	  pkp3=PKURPOS
	  call calcpos
          CALL METHGI(NPR,EPS,RED,PER,NI,IP,lhnl)
          CALL LHNL(pLHNUM)
	  IF (PLHNUM.GT.PMAXL) PMAXL=PLHNUM
C          WRITE(2,'(F6.2,A11,f10.5,A5,f10.5,16F8.4)') 
C     :		PKURPOS,' -2LN(LIK)=',-2.*PLHNUM,' LOD=',
C     :		PLHNUM-PLHDEN,(PR(K),K=1,16)
c          PRINT *,' LH LINKED=',pLHNUM
C          PRINT *,'POS,LOD',PKURPOS,pLHNUM-pLHDEN
          PKURPOS=PKURPOS+STEP
        END DO
402	continue
      end do

	WRITE(2,'(I6,A10,F10.5)')IPERM,' MAX.LOD=',PMAXL-PLHDEN
	print '(I6,A10,F10.5)',IPERM,' MAX.LOD=',PMAXL-PLHDEN
	end do

	DO I=1,NIND
	DO J=1,MAXTRA
	TRA(I,J)=TRA_old(I,J)
	END DO
	DO J=1,MAXMARK
	MARK(I,J)=MARK_OLD(I,J)
	END DO
	END DO

102	continue

      CLOSE(2)
      

      END                      
      
      INCLUDE 'PRG.F'
      INCLUDE 'METHGI.F'
      include 'stapar.f'
	include 'permute.f'

      SUBROUTINE LHNL(PLH)

	implicit double precision(a-h,o-z)

      include 'c_all.INC'
      REAL PNEM(8)
      call STAPAR(CH)        	
c	print *,'ch=',ch
      if (ch+1.e18) 999,92,92
92    continue
      PLH=0.
      PNEM(1)=PMU(1)
      PNEM(2)=PMU(1)+PMU(2)
      PNEM(3)=PMU(1)+PMU(3)
      PNEM(4)=PMU(1)+PMU(4)
      PNEM(5)=PMU(1)+PMU(2)+PMU(3)+PMU(5)
      PNEM(6)=PMU(1)+PMU(3)+PMU(4)+PMU(6)
      PNEM(7)=PMU(1)+PMU(2)+PMU(4)+PMU(7)
      PNEM(8)=PMU(1)+PMU(2)+PMU(3)+PMU(4)+PMU(5)+PMU(6)+PMU(7)+PMU(8)
	IF (IFLINK.EQ.0) THEN
          do iII=1,8
            propos(iII)=1./8.
          end do
	END IF
      DO I=1,NIND
        PTR=TRA(I,NCURTR)
	IF (IFLINK.EQ.1) THEN
          PPP1=cpospr(1,i)
          PPP2=cpospr(2,i)
          PPP3=cpospr(3,i)
	  propos(1)=(1.-ppp1)*(1.-ppp2)*(1.-ppp3)
          PROPOS(2)=ppp1*(1.-ppp2)*(1.-ppp3)
          PROPOS(3)=(1.-ppp1)*ppp2*(1.-ppp3)
          PROPOS(4)=(1.-ppp1)*(1.-ppp2)*ppp3
          PROPOS(5)=ppp1*ppp2*(1.-ppp3)
          PROPOS(6)=(1.-ppp1)*ppp2*ppp3
          PROPOS(7)=ppp1*(1.-ppp2)*ppp3
          PROPOS(8)=ppp1*ppp2*ppp3
	END IF
	prediction=0.
	do j=1,8
	prediction=prediction+propos(j)*pnem(j)
	end do
	preds=pr(9)
        PROB=0.
c	print *,i,ptr,preds,pr(9)
c	pause
	PROB=PNORM(PTR-prediction,preds)
        PLH=PLH+LOG10(PROB)
c	print '(i4,8f7.3)',i,ptr,ppp,pnem(1),pnem(2),prob
      END DO
c      PRINT *,'PLH=',PLH
c	pause
      RETURN
999   PLH=-1.E+17
      RETURN
      END

      FUNCTION PNORM(X,PSIG)

	implicit double precision(a-h,o-z)

      PI=3.141592
      PFT=1./SQRT(2*PI*PSIG)
      PST=EXP(-(X*X)/(2*PSIG))
      PNORM=PFT*PST
      RETURN
      END

	subroutine calcpos
	implicit double precision(a-h,o-z)
      include 'c_all.INC'

      DO I=1,NIND
          cpospr(1,i)=PRG(I,icg1,PKP1)
          cpospr(2,i)=PRG(I,icg2,PKP2)
          cpospr(3,i)=PRG(I,icg3,PKP3)
      end do
	return
	end

	subroutine sstop(message)
	character*255 message
	print *,message
	stop
	return
	end